'$INCLUDE: 'dash.bi'
'$DYNAMIC

DECLARE SUB WriteText (a$, TextColor, XCoordinate, YCoordinate, size)
DECLARE SUB FadeText (a$, TextColor, XCoordinate, YCoordinate, size, pse)
DECLARE SUB CheckTileSpace ()
DECLARE SUB CheckTileDown ()
DECLARE SUB CheckTileRight ()
DECLARE SUB CheckTileLeft ()
DECLARE SUB CheckTileUp ()
DECLARE SUB CheckTile ()
DECLARE SUB DrawPlayer ()
DECLARE SUB LoadGraphics ()
DECLARE SUB LoadText ()
DECLARE SUB DrawScreen ()
DECLARE SUB OpenMap ()
DECLARE SUB LoadMap ()
DECLARE SUB DrawStats ()
DECLARE SUB ReadNote ()
DECLARE SUB DrawBox (x3, y3, x4, y4, clr)
DECLARE SUB ShowItem (Item$)
DECLARE SUB ItemMenu ()
DECLARE SUB PutArrow ()
DECLARE SUB ItemStats (curX, curY)
DECLARE SUB OpenGate ()
DECLARE SUB GateLocked ()
DECLARE SUB Battle ()
DECLARE SUB MagicMenu ()
DECLARE SUB MagicStats (curX, curY)

COMMON SHARED ppx, ppy, pmx, pmy, mapx, mapy, MapName$, tileup, tiledown
COMMON SHARED tileright, tileleft, arrow, direction$, hp
COMMON SHARED mhp, mp, mmp, str, dfn, Agi, Wis, move, path$, gate, tilespot
COMMON SHARED ky, note, CursorX, CursorY, still, Fight, Fightm, lvl, xp, nxp
COMMON SHARED pot, mpot, gpot, antdt, wpnstr, bttl, itemused, scrlltxt, fball
COMMON SHARED ibeam, tshock, spellused, cast$, maxlvl

DIM SHARED Stone(201), Brick(201), gate(201), note(201), Dirt(201)
DIM SHARED Down1(451), Down2(451), Blank(201), charset(128, 8, 6), DownS(451)
DIM SHARED BrickTop(201), Flower(201), GateOpen(201), Tile(201)
DIM SHARED arrow(121), fountain(801), VIDEO(31999) AS INTEGER, ItemGPot(219)
DIM SHARED ItemKey(219), ItemNote(219), ItemPot(219), ItemMPot(219)
DIM SHARED ItemAntdt(219), SpellFball(219), SpellIbeam(219), SpellTshock(219)



'###########################################################################
'##############  Input the path to your SirChomps file below  ##############
'##############         Example: "C:\Progra~1\Chomps\"        ##############
                  path$ = ""
'###########################################################################



RANDOMIZE TIMER

ppx = 100
ppy = 100
pmx = 9
pmy = 8
move = 1
still = 0
Fight = INT(RND * 15) + 10

mhp = INT(RND * 20) + 40
hp = mhp
mmp = INT(RND * 10) + 5
mp = mmp
str = INT(RND * 3) + 5
dfn = INT(RND * 1) + 2
Agi = INT(RND + 4) + 3
Wis = INT(RND * 2) + 3
lvl = 1
xp = 0
nxp = INT(RND * 5) + 10


SCREEN 13

LoadGraphics
LoadText
VSPalette path$ + "SC"

MapName$ = "cell1": CALL OpenMap
REDIM SHARED Map(mapx, mapy)
                                   
                                   
LoadMap
DrawScreen
DrawStats
DrawPlayer

RefreshP:
CheckTile
DrawStats
DrawScreen
DrawPlayer
VSPCopy VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), &HA000, 0     'Buffer->Screen
GOTO Code

Refresh:
CheckTile
DrawScreen
DrawPlayer
VSPCopy VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), &HA000, 0     'Buffer->Screen

LOCATE 1, 1: PRINT pmx; pmy

'DO
'clr = clr + 1
'COLOR clr: LOCATE 1, 1: PRINT clr
'FOR pause = 1 TO 90000: NEXT
'LOOP

Code:
DO
  ass$ = INKEY$
  ass$ = RIGHT$(ass$, 1)
  SELECT CASE ass$

    CASE CHR$(27)                           'Esc Kay
      CALL DrawBox(38, 80, 265, 109, 999)
      CALL WriteText("Are you sure you want to quit?(y/n)", 15, 48, 90, 1)
      VSPCopy VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), &HA000, 0     'Buffer->Screen
      GOTO ToQuit

    CASE CHR$(32)                           'Space Bar
      tileup = Map(pmx, pmy - 1)
      tiledown = Map(pmx, pmy + 1)
      tileright = Map(pmx + 1, pmy)
      tileleft = Map(pmx - 1, pmy)
      tilespot = Map(pmx, pmy)
     CheckTileSpace
    
    CASE CHR$(72)                           ' Up Arrow
      pmy = pmy - 1
      direction$ = "north"
     CheckTileUp
     GOTO Refresh

    CASE CHR$(80)                           ' Down Arrow
      pmy = pmy + 1
      direction$ = "south"
     CheckTileDown
     GOTO Refresh

    CASE CHR$(77)                           ' Right Arrow
      pmx = pmx + 1
      direction$ = "east"
     CheckTileRight
     GOTO Refresh

    CASE CHR$(75)                           ' Left Arrow
      pmx = pmx - 1
      direction$ = "west"
      CheckTileLeft
     GOTO Refresh

    CASE CHR$(13)                           'Enter Key
      GOTO MenuBar

   
    CASE "i"
        ItemMenu
   
    CASE "I"
        ItemMenu

    CASE "m"
        MagicMenu

    CASE "M"
        MagicMenu

  END SELECT

IF still < 20000 THEN still = still + 1
IF still = 20000 AND move <> 10 THEN move = 10: DrawScreen: DrawPlayer: DrawStats
IF Fightm = Fight THEN CALL Battle
LOOP

ToQuit:

DO
  ass$ = INKEY$
   SELECT CASE ass$
   
    CASE "y"
      GOTO GameOver

    CASE "Y"
      GOTO GameOver

    CASE "n"
      GOTO RefreshP

    CASE "N"
      GOTO RefreshP
   END SELECT
LOOP

GameOver:
     FOR FadeBlack = 0 TO 40
        VSDelay 3
        VSFadeBlack 1
        IF FadeBlack > 39 THEN CLS : PALETTE: END
     NEXT

MenuBar:
DO: LOOP UNTIL INKEY$ = ""
clr = 28
spot = 1

MenuBar2:
CALL DrawBox(78, 50, 145, 150, 999)
CALL WriteText("Items", 15, 94, 63, 1)
CALL WriteText("Spells", 15, 94, 73, 1)
CALL WriteText("Options", 15, 94, 83, 1)
CALL WriteText("Exit", 15, 94, 93, 1)
VSPCopy VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), &HA000, 0     'Buffer->Screen

LOCATE 1, 1: PRINT spot

DO
  ass$ = INKEY$
  SELECT CASE ass$
    
     CASE CHR$(0) + "H"      'UpArrow
      IF spot <> 1 THEN spot = spot - 1: GOTO MenuBar2
      IF spot = 1 THEN spot = 4: GOTO MenuBar2

     CASE CHR$(0) + "P"      'DownArrow
      IF spot <> 4 THEN spot = spot + 1: GOTO MenuBar2
      IF spot = 4 THEN spot = 1: GOTO MenuBar2
    
     CASE CHR$(13)           'Enter
      IF spot = 1 THEN CALL ItemMenu: GOTO Refresh
      IF spot = 2 THEN CALL MagicMenu: GOTO Refresh
      IF spot = 4 THEN GOTO Refresh

     CASE CHR$(27)            'Esc Key
      GOTO Refresh
 
  END SELECT

scrlltxt = 900
IF spot = 1 THEN CALL WriteText("Items", clr, 94, 63, 1)
IF spot = 2 THEN CALL WriteText("Spells", clr, 94, 73, 1)
IF spot = 3 THEN CALL WriteText("Options", clr, 94, 83, 1)
IF spot = 4 THEN CALL WriteText("Exit", clr, 94, 93, 1)
scrlltxt = 0

IF clr > 0 AND clrup = 1 THEN clr = clr + 1
IF clr > 30 THEN clrup = 0
IF clr < 50 AND clrup = 0 THEN clr = clr - 1
IF clr < 17 THEN clrup = 1

FOR pause = 1 TO 9000: NEXT
LOOP

REM $STATIC
SUB Battle
bttl = 1

DO: LOOP UNTIL INKEY$ = ""

CALL DrawBox(70, 70, 250, 100, 999)
CALL FadeText("You Have Been Attacked!", 3, 999, 80, 1, 500)
VSPCopy VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), &HA000, 0     'Buffer->Screen

spot = 1
clr = 28

PickMonster:
monster = INT(RND * 5) + 1

IF monster = 1 AND lvl > 0 THEN
MonName$ = "Vworm"
MonMHP = 20
MonHP = 20
MonMMP = 0
MonMP = 0
MonStr = 8
MonDfn = 0
MonAgi = 7
MonWis = 1
MonXP = 3
weakness$ = "ice"
GOTO StartFight
END IF

IF monster = 2 AND lvl > 5 THEN
MonName$ = "Fly Guy"
MonMHP = 26
MonHP = 26
MonMMP = 0
MonMP = 0
MonStr = 12
MonDfn = 1
MonAgi = 15
MonWis = 1
MonXP = 5
GOTO StartFight
END IF

IF monster = 3 AND lvl > 14 THEN
MonName$ = "Bee Zee"
MonMHP = 36
MonHP = 36
MonMMP = 0
MonMP = 0
MonStr = 20
MonDfn = 3
MonAgi = 25
MonWis = 3
MonXP = 8
GOTO StartFight
END IF

IF monster = 4 AND lvl > 20 THEN
MonName$ = "Flutter Fly"
MonMHP = 50
MonHP = 50
MonMMP = 5
MonMP = 5
MonStr = 12
MonDfn = 5
MonAgi = 20
MonWis = 7
MonXP = 13
weakness$ = "thunder"
GOTO StartFight
END IF

IF monster = 5 AND lvl > 32 THEN
MonName$ = "Sand Vworm"
MonMHP = 100
MonHP = 100
MonMMP = 5
MonMP = 5
MonStr = 24
MonDfn = 5
MonAgi = 25
MonWis = 10
MonXP = 20
strength$ = "ice"
GOTO StartFight
END IF

IF monster = 6 AND lvl > 40 THEN
MonName$ = "Spider"
MonMHP = 146
MonHP = 146
MonMMP = 10
MonMP = 10
MonStr = 40
MonDfn = 8
MonAgi = 30
MonWis = 14
MonXP = 24
weakness$ = "fire"
GOTO StartFight
END IF

GOTO PickMonster

StartFight:
CALL DrawScreen
CALL DrawStats

CALL DrawBox(30, 5, 290, 100, 0)
CALL DrawBox(30, 105, 100, 195, 999)
CALL DrawBox(120, 105, 290, 195, 999)


text:
DO: LOOP UNTIL INKEY$ = ""
CALL WriteText("Attack", 15, 45, 58, 2)
CALL WriteText("Magic", 15, 45, 67, 2)
CALL WriteText("Item", 15, 45, 76, 2)
CALL WriteText("Run", 15, 45, 85, 2)

IF itemused = 1 THEN GOTO MonAttack
IF spellused = 1 THEN GOTO UseSpell

DO
  ass$ = INKEY$
  SELECT CASE ass$
  
     CASE CHR$(0) + "H"      'UpArrow
      IF spot <> 1 THEN spot = spot - 1: GOTO text
      IF spot = 1 THEN spot = 4: GOTO text

     CASE CHR$(0) + "P"      'DownArrow
      IF spot <> 4 THEN spot = spot + 1: GOTO text
      IF spot = 4 THEN spot = 1: GOTO text
     
     CASE CHR$(13)           'Enter
      IF spot = 1 THEN GOTO Fight
      IF spot = 2 THEN CALL MagicMenu: GOTO StartFight
      IF spot = 3 THEN CALL ItemMenu: GOTO StartFight
      IF spot = 4 THEN GOTO Rn

  END SELECT

scrlltxt = 900
IF spot = 1 THEN CALL WriteText("Attack", clr, 45, 58, 2)
IF spot = 2 THEN CALL WriteText("Magic", clr, 45, 67, 2)
IF spot = 3 THEN CALL WriteText("Item", clr, 45, 76, 2)
IF spot = 4 THEN CALL WriteText("Run", clr, 45, 85, 2)
scrlltxt = 0

IF clr > 0 AND clrup = 1 THEN clr = clr + 1
IF clr > 30 THEN clrup = 0
IF clr < 50 AND clrup = 0 THEN clr = clr - 1
IF clr < 17 THEN clrup = 1

FOR pause = 1 TO 9000: NEXT
LOOP


Rn:
IF Agi >= MonAgi THEN escape = INT(RND * 1)
IF MonAgi > Agi THEN escape = INT(RND * 3)
IF escape = 0 THEN GOTO Gone
IF Agi > MonAgi + 15 THEN GOTO Gone
CALL DrawBox(30, 70, 290, 110, 999)
CALL WriteText("Couldn't get away", 15, 100, 40, 2)
VSPCopy VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), &HA000, 0     'Buffer->Screen
SLEEP
GOTO StartFight

Gone:
CALL DrawBox(30, 70, 290, 110, 999)
CALL FadeText("Ran Away", 2, 130, 40, 2, 6000)
GOTO EndFight

Fight:
IF Agi > MonAgi THEN GOTO Attack
IF MonAgi > Agi THEN GOTO MonAttack


Attack:
Hit = INT(RND * MonAgi) + Agi
IF Hit < MonAgi THEN GOTO Miss

damage = INT(RND * str) + wpnstr - MonDfn
Special = INT(RND * 3) + 1
IF Special = 4 THEN damage = damage * 2: 'make some sound
IF damage < 1 THEN damage = 1

MonHP = MonHP - damage
CALL FadeText(STR$(damage), 3, 50, 50, 1, 2500)

IF poison = 1 THEN hp = hp - 1: damage = 1
CALL FadeText(STR$(damage), 3, 50, 50, 1, 2500)


IF MonHP < 1 THEN GOTO Victory
IF MonAgi > Agi THEN GOTO text

MonAttack:
itemused = 0

MonHit = INT(RND * Agi) + MonAgi
IF MonHit < Agi THEN GOTO MonMiss

MonDamage = INT(RND * MonStr) + 1 - dfn
MonSpecial = INT(RND * 5) + 1
IF MonSpecial = 6 THEN MonDamage = MonDamage * 2: 'make sound
IF MonDamage < 1 THEN MonDamage = 1

IF MonName$ = "Flutter Fly" THEN GOSUB FlutterFlyAttacks  'heal magic
IF MonName$ = "Sand Vworm" THEN GOSUB SandVwormAttacks 'black magic
IF MonName$ = "Spider" THEN GOSUB SpiderAttacks 'both

hp = hp - MonDamage
CALL FadeText(STR$(MonDamage), 3, 180, 80, 1, 2500)

AfterAI:
IF hp < 1 THEN GOTO Loss
IF MonAgi > Agi THEN GOTO Attack
GOTO text


Miss:
'Show Miss
FOR pause = 1 TO 90000: NEXT
IF MonAgi > Agi THEN GOTO text
GOTO MonAttack


MonMiss:
'Show Mon Miss
FOR pause = 1 TO 90000: NEXT
IF MonAgi > Agi THEN GOTO Attack
GOTO text


UseSpell:
IF cast$ = "fireball" THEN damage = INT((RND * Wis) + 20 + Wis / 5) - MonWis
IF cast$ = "ice beam" THEN damage = INT((RND * Wis) + 25 + Wis / 5) - MonWis
IF cast$ = "thunder shock" THEN damage = INT((RND * Wis) + 30 + Wis / 5) - MonWis

IF cast$ = "fireball" AND weakness$ = "fire" THEN damage = damage * 2
IF cast$ = "ice beam" AND weakness$ = "ice" THEN damage = damage * 2
IF cast$ = "thunder shock" AND weakness$ = "thunder" THEN damage = damage * 2

IF cast$ = "fireball" AND strength$ = "fire" THEN damage = damage / 2
IF cast$ = "ice beam" AND strength$ = "ice" THEN damage = damage / 2
IF cast$ = "thunder shock" AND strength$ = "thunder" THEN damage = damage / 2

IF damage < 1 THEN damage = 1
MonHP = MonHP - damage
CALL FadeText(STR$(damage), 3, 50, 50, 1, 2500)
spellused = 0
IF MonHP < 1 THEN GOTO Victory
GOTO MonAttack


MonSpell:
IF cast$ = "earth" THEN damage = INT((RND * MonWis) + 10 + MonWis / 5) - Wis
IF cast$ = "poison" THEN poison = 1: damage = INT((RND * MonWis) + 2 + MonWis / 5) - Wis

IF damage < 1 THEN damage = 1
hp = hp - damage
CALL FadeText(STR$(MonDamage), 3, 180, 80, 1, 2500)
GOTO AfterAI


FlutterFlyAttacks:
IF MonHP < 15 AND MonMP >= 2 THEN MonMP = MonMP - 2: MonHP = MonHP + 10: GOTO AfterAI
RETURN

SandVwormAttacks:
MonAtt = INT(RND * 2) + 1
IF MonAtt = 1 AND MonMP >= 3 THEN MonMP = MonMP - 3: cast$ = "earth": GOTO MonSpell
RETURN

SpiderAttacks:
MonAtt = INT(RND * 2) + 1
IF MonHP < 25 AND MonMP >= 2 THEN MonMP = MonMP - 2: MonHP = MonHP + 20: GOTO AfterAI
IF MonAtt = 1 AND MonMP >= 3 THEN MonMP = MonMP - 3: cast$ = "earth": GOTO MonSpell
IF MonAtt = 2 AND MonMP >= 4 AND poison = 0 THEN MonMP = MonMP - 4: cast$ = "poison": GOTO MonSpell
RETURN


Victory:
scrlltxt = 1
CALL DrawBox(20, 20, 300, 180, 999)
CALL FadeText("Victory!!!", 1, 120, 16, 2, 1)
CALL DrawBox(20, 60, 300, 180, 999)
CALL FadeText("You Gain:", 1, 30, 35, 2, 1)
IF MonXP < 10 THEN CALL FadeText(STR$(MonXP) + " experience points", 1, 40, 45, 2, 1)
IF MonXP >= 10 THEN CALL FadeText(STR$(MonXP) + " experience points", 1, 34, 45, 2, 1)
xp = xp + MonXP
GOSUB Rewards
IF gift$ <> "Nothing" THEN CALL FadeText("The " + MonName$ + " left:", 1, 30, 60, 2, 1)
IF gift$ <> "Nothing" THEN CALL FadeText("A " + gift$, 1, 45, 70, 2, 1)
GOSUB xp
VSPCopy VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), &HA000, 0     'Buffer->Screen
SLEEP
GOTO EndFight

Rewards:
rwd = INT(RND * 14) + 1
IF lvl < 20 THEN rwd = INT(RND * 12) + 1
IF lvl < 10 THEN rwd = INT(RND * 8) + 1
IF rwd = 1 AND pot < 100 OR rwd = 2 AND pot < 100 OR rwd = 3 AND pot < 100 THEN gift$ = "Potion": pot = pot + 1: RETURN
IF rwd = 4 AND lvl > 2 AND mpot < 100 OR rwd = 5 AND lvl > 2 AND mpot < 100 THEN gift$ = "Magic Potion": mpot = mpot + 1: RETURN
IF rwd = 6 AND lvl > 20 AND gpot < 100 THEN gift$ = "Great Potion": gpot = gpot + 1: RETURN
IF rwd = 7 AND lvl > 10 AND antdt < 100 THEN gift$ = "Antidote": antdt = antdt + 1: RETURN
gift$ = "Nothing"
RETURN

xp:
IF xp >= nxp AND maxlvl = 0 THEN
CALL DrawBox(145, 60, 300, 91, 999)
CALL FadeText("You Gained A Level!", 3, 168, 34, 2, 1)
CALL FadeText("You Gained A Level!", 1, 168, 34, 2, 1)
IF lvl = 4 THEN
CALL DrawBox(170, 89, 300, 120, 999)
CALL FadeText("Learned Fireball", 1, 185, 48, 2, 1)
fball = 1
END IF

IF lvl = 7 THEN
CALL DrawBox(170, 89, 300, 120, 999)
CALL FadeText("Learned Ice Beam", 1, 185, 48, 2, 1)
ibeam = 1
END IF

IF lvl = 11 THEN
CALL DrawBox(159, 89, 300, 120, 999)
CALL FadeText("Learned Thunder Shock", 1, 168, 48, 2, 1)
tshock = 1
END IF


DO
nxp = INT(nxp * 1.25)
mhp = INT(RND * 6) + mhp
mmp = INT(RND * 4) + mmp
str = INT(RND * 2) + str
dfn = INT(RND * 2) + dfn
Agi = INT(RND * 2) + Agi
Wis = INT(RND * 2) + Wis
lvl = lvl + 1
LOOP UNTIL xp < nxp
END IF

IF xp >= 9999 THEN maxlvl = 1

IF xp > 9999 THEN xp = 9999
IF nxp > 9999 THEN nxp = 9999
IF hp > 999 THEN hp = 999
IF mhp > 999 THEN mhp = 999
IF mp > 999 THEN mp = 999
IF mmp > 999 THEN mmp = 999
IF str > 99 THEN str = 99
IF dfn > 99 THEN dfn = 99
IF Agi > 99 THEN dfn = 99
IF Wis > 99 THEN Wis = 99
IF lvl > 99 THEN lvl = 99
RETURN


Loss:
CALL DrawBox(70, 70, 250, 100, 999)
CALL FadeText("You Have Been Defeated!", 1, 999, 80, 1, 500)
SLEEP 1
 FOR FadeBlack = 0 TO 40
  VSDelay 3
  VSFadeBlack 1
  IF FadeBlack > 39 THEN CLS : PALETTE: END
 NEXT
END




EndFight:
scrlltxt = 0
DrawStats
DrawScreen
DrawPlayer
VSPCopy VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), &HA000, 0     'Buffer->Screen

Fight = INT(RND * 15) + 10
Fightm = 0

bttl = 0

DO: LOOP WHILE INKEY$ = CHR$(13)
END SUB

REM $DYNAMIC
SUB CheckTile

Tile = Map(pmx, pmy)



IF pmx = 5 AND pmy = 10 AND MapName$ = "cell3" THEN MapName$ = "mhall1": OpenMap: LoadMap: pmx = 13: pmy = 16
IF pmx = 5 AND pmy = 10 AND MapName$ = "cell4" THEN MapName$ = "mhall1": OpenMap: LoadMap: pmx = 13: pmy = 16
                         
IF pmx = 15 AND pmy = 16 AND MapName$ = "mhall1" AND note = 0 THEN MapName$ = "cell3": OpenMap: LoadMap: pmx = 7: pmy = 10
IF pmx = 15 AND pmy = 16 AND MapName$ = "mhall1" AND note <> 0 THEN MapName$ = "cell4": OpenMap: LoadMap: pmx = 7: pmy = 10


END SUB

SUB CheckTileDown

Tile = Map(pmx, pmy)
                           
IF Tile < 60 THEN
    pmy = pmy - 1
END IF

IF Tile > 59 THEN
    move = move + 1
    Fightm = Fightm + 1
    IF poison = 1 THEN hp = hp - 1
    still = 0
END IF

END SUB

SUB CheckTileLeft

Tile = Map(pmx, pmy)

IF Tile < 60 THEN
    pmx = pmx + 1
END IF

IF Tile > 59 THEN
    move = move + 1
    Fightm = Fightm + 1
    IF poison = 1 THEN hp = hp - 1
    still = 0
END IF

END SUB

SUB CheckTileRight

Tile = Map(pmx, pmy)

IF Tile < 60 THEN
    pmx = pmx - 1
END IF

IF Tile > 59 THEN
    move = move + 1
    Fightm = Fightm + 1
    IF poison = 1 THEN hp = hp - 1
    still = 0
END IF

END SUB

SUB CheckTileSpace

IF tileup = 2 AND direction$ = "north" THEN note = 1: ReadNote: CALL ShowItem("Note")
IF tilespot = 61 AND ky = 0 THEN ky = 1: CALL ShowItem("ky")
IF tileleft = 3 AND direction$ = "west" AND ky <> 0 THEN gate = 1: CALL OpenGate
IF tileleft = 3 AND direction$ = "west" AND ky = 0 THEN CALL GateLocked

END SUB

SUB CheckTileUp

Tile = Map(pmx, pmy)

IF Tile < 60 THEN
    pmy = pmy + 1
END IF

IF Tile > 59 THEN
    move = move + 1
    Fightm = Fightm + 1
    IF poison = 1 THEN hp = hp - 1
    still = 0
END IF

END SUB

SUB DrawBox (x3, y3, x4, y4, clr)

IF clr <> 999 AND clr <> 998 THEN GOTO Boxes

Cy3 = y3
Cx3 = x3 + 4
Cx4 = x4 - 4
length = y4 - y3
C = 1

IF clr = 998 THEN Cy3 = y3 + 58

DO
lne = lne + 1
Cy3 = Cy3 + 1
VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), Cx3, Cx4, Cy3, C
IF lne < length * .9 THEN C = 55
IF lne < length * .8 THEN C = 56
IF lne < length * .7 THEN C = 57
IF lne < length * .6 THEN C = 58
IF lne < length * .5 THEN C = 59
IF lne < length * .4 THEN C = 60
IF lne < length * .3 THEN C = 61
IF lne < length * .2 THEN C = 62
IF lne < length * .1 THEN C = 63
LOOP UNTIL lne = length - 2
GOTO Edges


Boxes:
VSBox VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), x3 + 1, y3 + 1, x4 - 1, y4 - 1, clr

Edges:
C = 24
  DO
    x3 = x3 + 1
    y3 = y3 + 1
    x4 = x4 - 1
    y4 = y4 - 1
    C = C + 2
VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), x3, x4, y3, C
VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), x3, y3, y4, C

VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), x3, x4, y4, C
VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), x4, y3, y4, C

LOOP UNTIL C = 28

C = 28
  DO
    x3 = x3 + 1
    y3 = y3 + 1
    x4 = x4 - 1
    y4 = y4 - 1
    C = C - 2
VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), x3, x4, y3, C
VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), x3, y3, y4, C

VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), x3, x4, y4, C
VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), x4, y3, y4, C

LOOP UNTIL C = 20

END SUB

SUB DrawPlayer

IF move > 2 AND move <> 10 THEN move = 1

IF move = 1 AND still < 500 THEN VSSprite VARSEG(Down1(0)), VARPTR(Down1(0)), ppx - 6, ppy - 12, VARSEG(VIDEO(0)), VARPTR(VIDEO(0))
IF move = 2 AND still < 500 THEN VSSprite VARSEG(Down2(0)), VARPTR(Down2(0)), ppx - 6, ppy - 12, VARSEG(VIDEO(0)), VARPTR(VIDEO(0))

IF still > 500 THEN VSSprite VARSEG(DownS(0)), VARPTR(DownS(0)), ppx - 6, ppy - 12, VARSEG(VIDEO(0)), VARPTR(VIDEO(0))

END SUB

SUB DrawScreen

FOR x = -5 TO 5
    FOR y = -5 TO 4
        Tile = Map(pmx + x, pmy + y)
        spotx = ppx + x * 20
        spoty = ppy + y * 20

IF Tile = 0 THEN VSSprite VARSEG(Blank(0)), VARPTR(Blank(0)), spotx, spoty, VARSEG(VIDEO(0)), VARPTR(VIDEO(0))
IF Tile = 1 THEN VSSprite VARSEG(Brick(0)), VARPTR(Brick(0)), spotx, spoty, VARSEG(VIDEO(0)), VARPTR(VIDEO(0))
IF Tile = 2 THEN VSSprite VARSEG(note(0)), VARPTR(note(0)), spotx, spoty, VARSEG(VIDEO(0)), VARPTR(VIDEO(0))
IF Tile = 3 THEN VSSprite VARSEG(gate(0)), VARPTR(gate(0)), spotx, spoty, VARSEG(VIDEO(0)), VARPTR(VIDEO(0))
IF Tile = 4 THEN VSSprite VARSEG(BrickTop(0)), VARPTR(BrickTop(0)), spotx, spoty, VARSEG(VIDEO(0)), VARPTR(VIDEO(0))
IF Tile = 5 THEN VSSprite VARSEG(GateOpen(0)), VARPTR(GateOpen(0)), spotx, spoty, VARSEG(VIDEO(0)), VARPTR(VIDEO(0))
IF Tile = 60 THEN VSSprite VARSEG(Dirt(0)), VARPTR(Dirt(0)), spotx, spoty, VARSEG(VIDEO(0)), VARPTR(VIDEO(0))
IF Tile = 61 THEN VSSprite VARSEG(Flower(0)), VARPTR(Flower(0)), spotx, spoty, VARSEG(VIDEO(0)), VARPTR(VIDEO(0))

    NEXT y
NEXT x

END SUB

SUB DrawStats


VSBox VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), 220, 0, 320, 200, 16
CALL DrawBox(222, 0, 310, 200, 998)
CALL DrawBox(228, 6, 304, 61, 0)


'              |<--start                                      end-->|

CALL WriteText("Sir", 3, 255, 62, 1)
CALL WriteText("Chomps-A-Lot", 3, 231, 69, 1)

CALL WriteText("Level:" + STR$(lvl), 15, 231, 79, 1)
CALL WriteText("Exp:", 15, 231, 89, 1)
CALL WriteText(STR$(xp) + " /" + STR$(nxp), 15, 228, 99, 1)
CALL WriteText("HP:" + STR$(hp) + " /" + STR$(mhp), 15, 231, 109, 1)
CALL WriteText("MP:" + STR$(mp) + " /" + STR$(mmp), 15, 231, 119, 1)
CALL WriteText("Str:" + STR$(str), 15, 231, 129, 1)
CALL WriteText("Def:" + STR$(dfn), 15, 231, 139, 1)
CALL WriteText("Wis:" + STR$(Wis), 15, 231, 149, 1)
CALL WriteText("Agi:" + STR$(Agi), 15, 231, 159, 1)

CALL WriteText("Wpn:", 15, 231, 169, 1)
CALL WriteText("Armor:", 15, 269, 169, 1)

'IF ky = 2 THEN VSSprite VARSEG(ItemKey(0)), VARPTR(ItemKey(0)), 233, 177, VARSEG(VIDEO(0)), VARPTR(VIDEO(0))

VSPCopy VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), &HA000, 0     'Buffer->Screen
END SUB

REM $STATIC
SUB FadeText (a$, TextOp, XCoordinate, YCoordinate, size, pse)

IF TextOp = 2 THEN GOTO FadeOut

TextColor = 17
DO
CALL WriteText(a$, TextColor, XCoordinate, YCoordinate, size)
IF scrlltxt = 0 THEN TextColor = TextColor + 1
IF scrlltxt > 0 THEN TextColor = TextColor + 2
VSPCopy VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), &HA000, 0     'Buffer->Screen
FOR pause = 0 TO pse: NEXT
LOOP UNTIL TextColor >= 32
IF TextOp = 1 GOTO Done

FadeOut:
TextColor = 31
DO
CALL WriteText(a$, TextColor, XCoordinate, YCoordinate, size)
IF scrlltxt = 0 THEN TextColor = TextColor - 1
IF scrlltxt > 0 THEN TextColor = TextColor - 2
IF scrlltxt = 0 THEN VSPCopy VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), &HA000, 0     'Buffer->Screen
FOR pause = 0 TO pse: NEXT
LOOP UNTIL TextColor <= 15

Done:
END SUB

SUB GateLocked

CALL DrawBox(40, 100, 180, 123, 999)
CALL WriteText("The gate is locked.", 15, 55, 108, 1)
VSPCopy VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), &HA000, 0     'Buffer->Screen

END SUB

REM $DYNAMIC
SUB ItemMenu

CursorX = 11     'Drawing X-Y positions
CursorY = 10
clrup = 1
clr = 20
curX = 1    'Cursors X-Y positions on board
curY = 1    'For instance, 1-1 would mean it's on the Note

Start:
CALL DrawBox(2, 2, 217, 75, 55)
IF note <> 0 THEN VSSprite VARSEG(ItemNote(0)), VARPTR(ItemNote(0)), 12, 11, VARSEG(VIDEO(0)), VARPTR(VIDEO(0))
IF ky <> 0 THEN VSSprite VARSEG(ItemKey(0)), VARPTR(ItemKey(0)), 33, 11, VARSEG(VIDEO(0)), VARPTR(VIDEO(0))
IF pot <> 0 THEN VSSprite VARSEG(ItemPot(0)), VARPTR(ItemPot(0)), 52, 10, VARSEG(VIDEO(0)), VARPTR(VIDEO(0))
IF pot > 1 AND pot < 10 THEN CALL WriteText(STR$(pot), 15, 57, 20, 1)
IF pot > 9 THEN CALL WriteText(STR$(pot), 15, 51, 20, 1)
IF mpot <> 0 THEN VSSprite VARSEG(ItemMPot(0)), VARPTR(ItemMPot(0)), 72, 10, VARSEG(VIDEO(0)), VARPTR(VIDEO(0))
IF mpot > 1 AND mpot < 10 THEN CALL WriteText(STR$(mpot), 15, 77, 20, 1)
IF mpot > 9 THEN CALL WriteText(STR$(mpot), 15, 71, 20, 1)
IF gpot <> 0 THEN VSSprite VARSEG(ItemGPot(0)), VARPTR(ItemGPot(0)), 92, 10, VARSEG(VIDEO(0)), VARPTR(VIDEO(0))
IF gpot > 1 AND gpot < 10 THEN CALL WriteText(STR$(gpot), 15, 97, 20, 1)
IF gpot > 9 THEN CALL WriteText(STR$(gpot), 15, 91, 20, 1)
IF antdt <> 0 THEN VSSprite VARSEG(ItemAntdt(0)), VARPTR(ItemAntdt(0)), 112, 10, VARSEG(VIDEO(0)), VARPTR(VIDEO(0))
IF antdt > 1 AND antdt < 10 THEN CALL WriteText(STR$(antdt), 15, 117, 20, 1)
IF antdt > 9 THEN CALL WriteText(STR$(antdt), 15, 111, 20, 1)

CALL DrawStats

DO
  ass$ = INKEY$
  SELECT CASE ass$
    
     CASE CHR$(27)           'Esc
      GOTO Over
    
     CASE CHR$(0) + "H"      'UpArrow
      IF curY <> 1 THEN              'covers old cursor position over in blue
        VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorX + 4, CursorY, 55
        VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorY, CursorY + 4, 55
        VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 13, CursorX + 17, CursorY, 55
        VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 17, CursorY, CursorY + 4, 55
        VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorX + 4, CursorY + 17, 55
        VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorY + 13, CursorY + 17, 55
        VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 13, CursorX + 17, CursorY + 17, 55
        VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 17, CursorY + 13, CursorY + 17, 55
        curY = curY - 1   'move up an item
        CursorY = CursorY - 20
      END IF

     CASE CHR$(0) + "P"      'DownArrow
      IF curY <> 3 THEN              'covers old cursor position over in blue
        VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorX + 4, CursorY, 55
        VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorY, CursorY + 4, 55
        VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 13, CursorX + 17, CursorY, 55
        VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 17, CursorY, CursorY + 4, 55
        VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorX + 4, CursorY + 17, 55
        VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorY + 13, CursorY + 17, 55
        VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 13, CursorX + 17, CursorY + 17, 55
        VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 17, CursorY + 13, CursorY + 17, 55
        curY = curY + 1   'move up an item
        CursorY = CursorY + 20
      END IF
                    
     CASE CHR$(13)           'Enter
      IF curX = 1 AND curY = 1 AND note <> 0 THEN CALL ReadNote
      IF curX = 3 AND curY = 1 AND pot <> 0 THEN hp = hp + 50: IF hp > mhp THEN hp = mhp: pot = pot - 1: GOSUB CheckBattle
      IF curX = 4 AND curY = 1 AND mpot <> 0 THEN mp = mp + 10: IF mp > mmp THEN mp = mmp: mpot = mpot - 1: GOSUB CheckBattle
      IF curX = 5 AND curY = 1 AND gpot <> 0 THEN hp = hp + 150: IF hp > mhp THEN hp = mhp: gpot = gpot - 1: GOSUB CheckBattle
      IF curX = 6 AND curY = 1 AND antdt <> 0 THEN poison = 0: antdt = antdt - 1: GOSUB CheckBattle
      GOTO Start
    
     CASE CHR$(0) + "K"      'LeftArrow
      IF curX <> 1 THEN              'covers old cursor position over in blue
        VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorX + 4, CursorY, 55
        VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorY, CursorY + 4, 55
        VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 13, CursorX + 17, CursorY, 55
        VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 17, CursorY, CursorY + 4, 55
        VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorX + 4, CursorY + 17, 55
        VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorY + 13, CursorY + 17, 55
        VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 13, CursorX + 17, CursorY + 17, 55
        VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 17, CursorY + 13, CursorY + 17, 55
        curX = curX - 1   'move up an item
        CursorX = CursorX - 20
      END IF
   
     CASE CHR$(0) + "M"      'RightArrow
      IF curX <> 10 THEN              'covers old cursor position over in blue
        VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorX + 4, CursorY, 55
        VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorY, CursorY + 4, 55
        VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 13, CursorX + 17, CursorY, 55
        VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 17, CursorY, CursorY + 4, 55
        VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorX + 4, CursorY + 17, 55
        VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorY + 13, CursorY + 17, 55
        VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 13, CursorX + 17, CursorY + 17, 55
        VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 17, CursorY + 13, CursorY + 17, 55
        curX = curX + 1   'move up an item
        CursorX = CursorX + 20
      END IF
                   
                   


  END SELECT

'top left
VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorX + 4, CursorY, clr
VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorY, CursorY + 4, clr
'top right
VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 13, CursorX + 17, CursorY, clr
VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 17, CursorY, CursorY + 4, clr
'bottom left
VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorX + 4, CursorY + 17, clr
VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorY + 13, CursorY + 17, clr
'bottom right
VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 13, CursorX + 17, CursorY + 17, clr
VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 17, CursorY + 13, CursorY + 17, clr

IF clr > 0 AND clrup = 1 THEN clr = clr + 1
IF clr > 30 THEN clrup = 0
IF clr < 50 AND clrup = 0 THEN clr = clr - 1
IF clr < 17 THEN clrup = 1
VSPCopy VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), &HA000, 0     'Buffer->Screen
CALL ItemStats(curX, curY)
FOR pause = 1 TO 9000: NEXT
LOOP

CheckBattle:
IF bttl = 0 THEN RETURN
itemused = 1

Over:
DrawScreen
DrawStats
DrawPlayer
VSPCopy VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), &HA000, 0     'Buffer->Screen

END SUB

REM $STATIC
SUB ItemStats (curX, curY)
CALL DrawBox(2, 73, 217, 120, 999)

IF curX = 1 AND curY = 1 AND note <> 0 THEN
   CALL WriteText("Note From Draconis:", 47, 10, 80, 1)
   CALL WriteText("This is the note you found on the", 15, 15, 88, 1)
   CALL WriteText("wall after Draconis ditched you", 15, 15, 96, 1)
   CALL WriteText("down in the cell.", 15, 15, 104, 1)
END IF

IF curX = 2 AND curY = 1 AND ky <> 0 THEN
   CALL WriteText("Cell Key:", 47, 10, 80, 1)
   CALL WriteText("The key you found by the flower.", 15, 15, 88, 1)
   CALL WriteText("Opens the door to the cell.", 15, 15, 96, 1)
END IF

IF curX = 3 AND curY = 1 AND pot <> 0 THEN
   CALL WriteText("Heal Potion:", 47, 10, 80, 1)
   CALL WriteText("This heal potion will restore", 15, 15, 88, 1)
   CALL WriteText("up to 50 hit points.", 15, 15, 96, 1)
END IF

IF curX = 4 AND curY = 1 AND mpot <> 0 THEN
   CALL WriteText("Magic Potion:", 47, 10, 80, 1)
   CALL WriteText("This magic potion will restore", 15, 15, 88, 1)
   CALL WriteText("up to 10 magic points.", 15, 15, 96, 1)
END IF

IF curX = 5 AND curY = 1 AND gpot <> 0 THEN
   CALL WriteText("Great Heal Potion:", 47, 10, 80, 1)
   CALL WriteText("This heal potion will restore up", 15, 15, 88, 1)
   CALL WriteText("to 150 hit points.", 15, 15, 96, 1)
END IF

IF curX = 6 AND curY = 1 AND antdt <> 0 THEN
   CALL WriteText("Antidote:", 47, 10, 80, 1)
   CALL WriteText("This antidote potion will heal", 15, 15, 88, 1)
   CALL WriteText("all status ailments (ie. poison)", 15, 15, 96, 1)
END IF


END SUB

REM $DYNAMIC
SUB LoadGraphics

CLS
SCREEN 13
LINE (0, 0)-(20, 20), 17, BF
GET (0, 0)-(20, 20), Blank
CLS


'---=== Map Elements ===---
DEF SEG = VARSEG(Stone(0)): BLOAD path$ + "Images\Stone.mdt", VARPTR(Stone(0)): DEF SEG
DEF SEG = VARSEG(Tile(0)): BLOAD path$ + "Images\Tile.mdt", VARPTR(Tile(0)): DEF SEG
DEF SEG = VARSEG(Brick(0)): BLOAD path$ + "Images\Brick.grh", VARPTR(Brick(0)): DEF SEG
DEF SEG = VARSEG(BrickTop(0)): BLOAD path$ + "Images\BrickTop.grh", VARPTR(BrickTop(0)): DEF SEG
DEF SEG = VARSEG(note(0)): BLOAD path$ + "Images\Note.grh", VARPTR(note(0)): DEF SEG
DEF SEG = VARSEG(gate(0)): BLOAD path$ + "Images\Gate.grh", VARPTR(gate(0)): DEF SEG
DEF SEG = VARSEG(GateOpen(0)): BLOAD path$ + "Images\GateO.grh", VARPTR(GateOpen(0)): DEF SEG
DEF SEG = VARSEG(Dirt(0)): BLOAD path$ + "Images\Dirt.grh", VARPTR(Dirt(0)): DEF SEG
DEF SEG = VARSEG(arrow(0)): BLOAD path$ + "Images\arrow.grh", VARPTR(arrow(0)): DEF SEG
DEF SEG = VARSEG(Flower(0)): BLOAD path$ + "Images\flower.grh", VARPTR(Flower(0)): DEF SEG
'---===**************===---

'---=== Character GFX ===---
DEF SEG = VARSEG(Down1(0)): BLOAD path$ + "Images\Sc_Down1.gfx", VARPTR(Down1(0)): DEF SEG
DEF SEG = VARSEG(Down2(0)): BLOAD path$ + "Images\Sc_Down2.gfx", VARPTR(Down2(0)): DEF SEG
DEF SEG = VARSEG(DownS(0)): BLOAD path$ + "Images\Sc_DownS.gfx", VARPTR(DownS(0)): DEF SEG
'---===***************===---

'---=== Items ===---
DEF SEG = VARSEG(ItemNote(0)): BLOAD path$ + "Images\note.itm", VARPTR(ItemNote(0)): DEF SEG
DEF SEG = VARSEG(ItemKey(0)): BLOAD path$ + "Images\key.itm", VARPTR(ItemKey(0)): DEF SEG
DEF SEG = VARSEG(ItemPot(0)): BLOAD path$ + "Images\pot.itm", VARPTR(ItemPot(0)): DEF SEG
DEF SEG = VARSEG(ItemMPot(0)): BLOAD path$ + "Images\mpot.itm", VARPTR(ItemMPot(0)): DEF SEG
DEF SEG = VARSEG(ItemGPot(0)): BLOAD path$ + "Images\gpot.itm", VARPTR(ItemGPot(0)): DEF SEG
DEF SEG = VARSEG(ItemAntdt(0)): BLOAD path$ + "Images\Antdt.itm", VARPTR(ItemAntdt(0)): DEF SEG
'---===*******===---

'---=== Spells ===---
DEF SEG = VARSEG(SpellFball(0)): BLOAD path$ + "Images\FBall.mag", VARPTR(SpellFball(0)): DEF SEG
DEF SEG = VARSEG(SpellIbeam(0)): BLOAD path$ + "Images\Ibeam.mag", VARPTR(SpellIbeam(0)): DEF SEG
DEF SEG = VARSEG(SpellTshock(0)): BLOAD path$ + "Images\Tshock.mag", VARPTR(SpellTshock(0)): DEF SEG
'---===********===---


END SUB

SUB LoadMap

FOR y = 1 TO mapx
    FOR x = 1 TO mapy
        INPUT #1, Map(x, y)
    NEXT x
NEXT y

CLOSE #1
                    
DrawScreen
DrawPlayer
DrawStats
VSPCopy VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), &HA000, 0     'Buffer->Screen

END SUB

SUB LoadText

OPEN path$ + "font.dat" FOR INPUT AS #2

FOR a = 1 TO 126
FOR x = 1 TO 8
    
      FOR y = 1 TO 6
        INPUT #2, b
        charset(a, x, y) = b
      NEXT y

   NEXT x
NEXT a

CLOSE


END SUB

REM $STATIC
SUB MagicMenu

CursorX = 11     'Drawing X-Y positions
CursorY = 10
clrup = 1
clr = 20
curX = 1    'Cursors X-Y positions on board
curY = 1    'For instance, 1-1 would mean it's on the Note

MStart:
CALL DrawBox(2, 2, 217, 75, 55)
IF fball <> 0 THEN VSSprite VARSEG(SpellFball(0)), VARPTR(SpellFball(0)), 12, 11, VARSEG(VIDEO(0)), VARPTR(VIDEO(0))
IF ibeam <> 0 THEN VSSprite VARSEG(SpellIbeam(0)), VARPTR(SpellIbeam(0)), 33, 11, VARSEG(VIDEO(0)), VARPTR(VIDEO(0))
IF tshock <> 0 THEN VSSprite VARSEG(SpellTshock(0)), VARPTR(SpellTshock(0)), 53, 12, VARSEG(VIDEO(0)), VARPTR(VIDEO(0))

CALL DrawStats

DO
  ass$ = INKEY$
  SELECT CASE ass$
   
     CASE CHR$(27)           'Esc
      GOTO MOver
   
     CASE CHR$(0) + "H"      'UpArrow
      IF curY <> 1 THEN              'covers old cursor position over in blue
        VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorX + 4, CursorY, 55
        VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorY, CursorY + 4, 55
        VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 13, CursorX + 17, CursorY, 55
        VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 17, CursorY, CursorY + 4, 55
        VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorX + 4, CursorY + 17, 55
        VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorY + 13, CursorY + 17, 55
        VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 13, CursorX + 17, CursorY + 17, 55
        VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 17, CursorY + 13, CursorY + 17, 55
        curY = curY - 1   'move up an item
        CursorY = CursorY - 20
      END IF

     CASE CHR$(0) + "P"      'DownArrow
      IF curY <> 3 THEN              'covers old cursor position over in blue
        VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorX + 4, CursorY, 55
        VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorY, CursorY + 4, 55
        VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 13, CursorX + 17, CursorY, 55
        VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 17, CursorY, CursorY + 4, 55
        VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorX + 4, CursorY + 17, 55
        VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorY + 13, CursorY + 17, 55
        VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 13, CursorX + 17, CursorY + 17, 55
        VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 17, CursorY + 13, CursorY + 17, 55
        curY = curY + 1   'move up an item
        CursorY = CursorY + 20
      END IF
                   
     CASE CHR$(13)           'Enter Key
      IF curX = 1 AND curY = 1 AND fball = 1 AND mp >= 3 AND bttl = 1 THEN mp = mp - 3: cast$ = "fireball": GOTO MCheckBattle
      IF curX = 2 AND curY = 1 AND ibeam = 1 AND mp >= 4 AND bttl = 1 THEN mp = mp - 4: cast$ = "ice beam": GOTO MCheckBattle
      IF curX = 3 AND curY = 1 AND tshock = 1 AND mp >= 5 AND bttl = 1 THEN mp = mp - 5: cast$ = "thunder shock": GOTO MCheckBattle
     
     CASE CHR$(0) + "K"      'LeftArrow
      IF curX <> 1 THEN              'covers old cursor position over in blue
        VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorX + 4, CursorY, 55
        VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorY, CursorY + 4, 55
        VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 13, CursorX + 17, CursorY, 55
        VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 17, CursorY, CursorY + 4, 55
        VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorX + 4, CursorY + 17, 55
        VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorY + 13, CursorY + 17, 55
        VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 13, CursorX + 17, CursorY + 17, 55
        VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 17, CursorY + 13, CursorY + 17, 55
        curX = curX - 1   'move up an item
        CursorX = CursorX - 20
      END IF
  
     CASE CHR$(0) + "M"      'RightArrow
      IF curX <> 10 THEN              'covers old cursor position over in blue
        VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorX + 4, CursorY, 55
        VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorY, CursorY + 4, 55
        VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 13, CursorX + 17, CursorY, 55
        VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 17, CursorY, CursorY + 4, 55
        VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorX + 4, CursorY + 17, 55
        VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorY + 13, CursorY + 17, 55
        VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 13, CursorX + 17, CursorY + 17, 55
        VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 17, CursorY + 13, CursorY + 17, 55
        curX = curX + 1   'move up an item
        CursorX = CursorX + 20
      END IF
                  
                  


  END SELECT

'top left
VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorX + 4, CursorY, clr
VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorY, CursorY + 4, clr
'top right
VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 13, CursorX + 17, CursorY, clr
VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 17, CursorY, CursorY + 4, clr
'bottom left
VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorX + 4, CursorY + 17, clr
VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX, CursorY + 13, CursorY + 17, clr
'bottom right
VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 13, CursorX + 17, CursorY + 17, clr
VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), CursorX + 17, CursorY + 13, CursorY + 17, clr

IF clr > 0 AND clrup = 1 THEN clr = clr + 1
IF clr > 30 THEN clrup = 0
IF clr < 50 AND clrup = 0 THEN clr = clr - 1
IF clr < 17 THEN clrup = 1
VSPCopy VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), &HA000, 0     'Buffer->Screen
CALL MagicStats(curX, curY)
FOR pause = 1 TO 9000: NEXT
LOOP

MCheckBattle:
IF bttl = 0 THEN RETURN
spellused = 1

MOver:
DrawScreen
DrawStats
DrawPlayer
VSPCopy VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), &HA000, 0     'Buffer->Screen

END SUB

SUB MagicStats (curX, curY)
CALL DrawBox(2, 73, 217, 120, 999)

IF curX = 1 AND curY = 1 AND fball <> 0 THEN
   CALL WriteText("Fire Ball (3mp):", 47, 10, 80, 1)
   CALL WriteText("A fiery ball of flame projected", 15, 15, 88, 1)
   CALL WriteText("against a single enemy.", 15, 15, 96, 1)
END IF

IF curX = 2 AND curY = 1 AND ibeam <> 0 THEN
   CALL WriteText("Ice Beam (4mp):", 47, 10, 80, 1)
   CALL WriteText("A beam of ice blasts from your", 15, 15, 88, 1)
   CALL WriteText("body to put the enemy on freeze.", 15, 15, 96, 1)
END IF

IF curX = 3 AND curY = 1 AND tshock <> 0 THEN
   CALL WriteText("Thunder Shock (5mp):", 47, 10, 80, 1)
   CALL WriteText("Lightening reigns down from the", 15, 15, 88, 1)
   CALL WriteText("heavens and fries your enemy", 15, 15, 96, 1)
END IF


END SUB

SUB OpenGate

IF note <> 0 AND MapName$ <> "cell4" THEN MapName$ = "cell4": CALL OpenMap: LoadMap
IF note = 0 AND MapName$ <> "cell3" THEN MapName$ = "cell3": CALL OpenMap: LoadMap

CALL DrawBox(27, 100, 200, 123, 999)
CALL WriteText("You have unlocked the gate.", 15, 35, 108, 1)
VSPCopy VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), &HA000, 0     'Buffer->Screen

END SUB

REM $DYNAMIC
SUB OpenMap

OPEN path$ + MapName$ + ".map" FOR INPUT AS #1
INPUT #1, mapx, mapy

END SUB

SUB PutArrow

VSSprite VARSEG(arrow(0)), VARPTR(arrow(0)), 300, 43, VARSEG(VIDEO(0)), VARPTR(VIDEO(0))


END SUB

SUB ReadNote

CALL DrawBox(1, 1, 320, 52, 999)
                                                                
scrlltxt = 4000
DrawBox 1, 1, 320, 52, 999
    CALL WriteText("  Dear Sir Chomps-A-Lot:", 15, 1, 9, 1)
    CALL WriteText("  To put your wretched mind at ease, your granny", 15, 1, 18, 1)
    CALL WriteText("  is fine. That was one of my men on the phone.", 15, 1, 27, 1)
    CALL WriteText("  He did a fine job of luring you out. In several", 15, 1, 36, 1)
        PutArrow
VSPCopy VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), &HA000, 0
DO: LOOP WHILE INKEY$ = ""


DrawBox 1, 1, 320, 52, 999
    CALL WriteText("  weeks we shall come for you and gather your bones", 15, 1, 9, 1)
    CALL WriteText("  to feed to the sharks. 'Til then, have fun!", 15, 1, 18, 1)
    CALL WriteText("Sincerely,", 15, 230, 27, 1)
    CALL WriteText("Draconis", 15, 248, 36, 1)
VSPCopy VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), &HA000, 0

scrlltxt = 0
DO: LOOP WHILE INKEY$ = ""
IF gate = 0 AND MapName$ = "cell1" OR MapName$ = "cell3" THEN MapName$ = "cell2": CALL OpenMap: LoadMap
IF gate = 1 AND MapName$ = "cell1" OR MapName$ = "cell3" THEN MapName$ = "cell4": CALL OpenMap: LoadMap
DrawScreen
DrawStats
DrawPlayer
VSPCopy VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), &HA000, 0

DO: LOOP UNTIL INKEY$ = ""
END SUB

SUB ShowItem (Item$)

DrawBox 2, 2, 217, 64, 999
PLAY "l64 <<<<aabb>ccddeeffgg"
SELECT CASE Item$
   
    CASE "ky"
        CALL WriteText("You bend over to look at the", 15, 10, 10, 1)
        CALL WriteText("flower on the ground and", 15, 10, 19, 1)
        CALL WriteText("find a    .", 15, 10, 28, 1)
        CALL WriteText("       key", 47, 10, 28, 1)
        VSSprite VARSEG(ItemKey(0)), VARPTR(ItemKey(0)), 14, 35, VARSEG(VIDEO(0)), VARPTR(VIDEO(0))
       
    CASE "Note"
        CALL WriteText("You take the      off the wall!", 15, 10, 10, 1)
        CALL WriteText("             note", 47, 10, 10, 1)
        VSSprite VARSEG(ItemNote(0)), VARPTR(ItemNote(0)), 14, 19, VARSEG(VIDEO(0)), VARPTR(VIDEO(0))

END SELECT
VSPCopy VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), &HA000, 0     'Buffer->Screen
DO: LOOP WHILE INKEY$ = ""
DrawScreen
DrawStats
DrawPlayer
VSPCopy VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), &HA000, 0     'Buffer->Screen
END SUB

SUB WriteText (a$, TextColor, XCoordinate, YCoordinate, size)

size = INT(size)
IF size > 10 THEN size = 10
IF size < 1 THEN size = 1

YCoordinate = INT(YCoordinate)
XCoordinate = INT(XCoordinate)

IF XCoordinate = 999 THEN XCoordinate = 160 - (LEN(a$) * 3 * size)

startx = XCoordinate

FOR e = 1 TO LEN(a$)

   b$ = MID$(a$, e, 1)
   a = ASC(b$)

      FOR x = 1 TO 8

         FOR y = 1 TO 6

            SELECT CASE charset(a, x, y)
                                          
                                          

               CASE 0: col = 0

               CASE 1: col = TextColor
             
               CASE ELSE
                  CLS
                  SCREEN 9
                  COLOR 4
                    PRINT "Invalid Font DATA."
                    PRINT
                    PRINT "This is usually caused by modifiction of"
                    PRINT "FONTDATA.DAT file."
                    PRINT
                    PRINT "Contact BattleCraft99 at BattleCraft99@hotmail.com"
                    PRINT "for a new copy of the font data."
                  DO: LOOP UNTIL INKEY$ <> ""
                  SCREEN 13

            END SELECT

          IF col <> 0 THEN
            VSYLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), startx + pixelsright, (x + YCoordinate) * size, ((x + YCoordinate) * size) + size - 1, TextColor
            'VSXLine VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), startx + pixelsright, startx + pixelsright + (size - 1), (x + YCoordinate) * size, TextColor
          END IF
         
          IF size = 1 THEN startx = startx + size
          IF size = 2 THEN startx = startx + size - 1
       
        NEXT y
     
       startx = XCoordinate
    
     NEXT x
  
   pixelsright = pixelsright + 6
   
IF scrlltxt > 0 THEN
FOR pause = 0 TO scrlltxt: NEXT
VSPCopy VARSEG(VIDEO(0)), VARPTR(VIDEO(0)), &HA000, 0     'Buffer->Screen
END IF

NEXT e

END SUB

